# predictive distributions for all species

#setwd("C:/")   #insert path to where data and code for functions are kept

load("spgroup.output.Rdata")     #contains output of diametergrow.r, insert spgroup name


X1 <- NULL
mgrow <- NULL
elv <-NULL
predGrow <- NULL
predGrowProc <- NULL
predGrowSd <- NULL
eseq <- NULL
aincr1 <- NULL
md.elv <- NULL
mp.elv <- NULL
md.pred <- NULL
mp.pred <- NULL


i=1
  keep <- c(burnin:g)
  nk   <- length(keep)

  X1[[i]] <- X
  mgrow[[i]] <- ggibbs/nk
  elv[[i]] <- covars[,2]
  aincr1[[i]] <- aincr
  md.elv[i] <- median(covars[,2])
  mp.elv[i] <- mean(range(covars[,2]))  

##################predictive distributions for covariates

nsim <- 5000
yindex <- sample(c(1:(nt-1)),nsim,replace=T) #  or yindex <- rep(2,nsim) for yr 2

q <- c(.5,.8,.9)

xq <- apply(X,2,quantile,q)                   #quantiles for each covariate
xm <- apply(X,2,mean)                         #mean for each covariate

eseq[[i]] <- seq(min(X[,'elev']),max(X[,'elev']),length.out=20)        #sequence of elevations

gs <- sample(keep,nsim)      # sample of the gibbs steps after burnin


predGrow[[i]] <- matrix(0,length(eseq[[i]]),9)                                                               #matrix for predictions for each quantile, includes individual effects
colnames(predGrow[[i]]) <- as.vector(t(outer(c('SU','SG','CA'),c(.5,.025,.975),paste,sep='-')))         #SU = sapling, understory; SG = sapling, gap; CA = canopy adult
rownames(predGrow[[i]]) <- signif(eseq[[i]],4)

predGrowProc[[i]] <- predGrow[[i]]         #matrix for predictions for each quantile, does not include individual effects, only process error
predGrowSd[[i]] <- predGrow[[i]]           #matrix for standard errors for each quantile

kseq <- c(-2:0)
                                 #find predictions for each quantile
for(k in 1:3){

  kseq <- kseq + 3
  xmj <- rep(1,4)
  if(k == 1){             #which scenario are we simulating?
    xmj[2] <- 1           #canopy status = 1
    xmj[3] <- 1           #dbh = 10cm
  }
  if(k == 2){
    xmj[2] <- 3           #canopy status = 3
    xmj[3] <- 1           #dbh = 10 cm
  }
  if(k == 3){
    xmj[2] <- 3              #canopy status = 3
    xmj[3] <- xq[2,'dbh']    #dbh = 80th quantile
  }

  for(j in 1:length(eseq[[i]])){                #simulate for each elevation

  ejk <- eseq[[i]][j] + (k-1)/100         #jitter points

  xj <- matrix(xmj,nsim,ncol(X),byrow=T)  #matix of specified covariates for each simulation
  xj[,4] <- eseq[[i]][j]
  
  tj <- tgibbs[gs,]                                    # sample year effects
  tj <- tj[cbind(c(1:nsim),yindex)]

  sj <- sgibbs[gs,cbind('proc','ind','plot')]          # sample process, individual, and plot(zero here) error

  y1 <- apply( xj*agibbs[gs,],1,sum) + tj              #growth for each simulted tree (summed effects)
  yy <- quantile(y1,c(.5,.025,.975))
  predGrowSd[[i]][j,kseq] <- yy                             #standard error of growth

  if (k==3) {
    xj[,4] <- md.elv[i]
    y3 <- apply( xj*agibbs[gs,],1,sum) + tj              #growth for each simulted tree (summed effects)
    md.pred[[i]] <- quantile(y3,.5)     }                #prediction for adult tree at median elevation
    #same as above using range midpoint
    xj[,4] <- mp.elv[i]
    y4 <- apply( xj*agibbs[gs,],1,sum) + tj              #growth for each simulted tree (summed effects)
    mp.pred[[i]] <- quantile(y4,.5)     }                #prediction for adult tree at midpoint elevation
  
  y2 <- rnorm(nsim,y1,sqrt(apply(sj,1,sum)))
  yy <- quantile(y2,c(.5,.025,.975))
  predGrow[[i]][j,kseq] <- yy                               #including process and individual variability

  sj <- sgibbs[gs,'proc']
  y2 <- rnorm(nsim,y1,sqrt(sj))
  yy <- quantile(y2,c(.5,.025,.975))
  predGrowProc[[i]][j,kseq] <- yy                          #includes only process error
  }

save.image(file=paste(spgroup,".prediction.RData",sep=""))   #write output to file
  
##### Plot predicted growth of scenarios across species range 

par(mfrow=c(1,1),lwd=2,las=1)

  
sp.range <- range(covars[,2])
a=1
           
  avggrow <- apply(mgrow[[a]],1,mean,na.rm=T)
  plot(elv[[a]]*1000,avggrow,xlab="Altitude (meters)",ylab="Mean diameter increment (cm)",main=spgroup,ylim=c(0,.5),xlim=sp.range*1000)

lines(eseq[[a]]*1000,predGrowSd[[a]][,1],type='l',lwd=3,col="darkgray")
lines(eseq[[a]]*1000,predGrowSd[[a]][,2],lty=2,col="darkgray")
lines(eseq[[a]]*1000,predGrowSd[[a]][,3],lty=2,col="darkgray")

lines(eseq[[a]]*1000,predGrowSd[[a]][,4],type='l',lwd=3,col="lightgray")
lines(eseq[[a]]*1000,predGrowSd[[a]][,5],lty=2,col="lightgray")
lines(eseq[[a]]*1000,predGrowSd[[a]][,6],lty=2,col="lightgray")

lines(eseq[[a]]*1000,predGrowSd[[a]][,7],type='l',lwd=3)      #plotting mean and standard error
lines(eseq[[a]]*1000,predGrowSd[[a]][,8],lty=2)
lines(eseq[[a]]*1000,predGrowSd[[a]][,9],lty=2)


##########




